diff --git a/base/deploy/src/scriptlets/pkiparser.py b/base/deploy/src/scriptlets/pkiparser.py
index 0add192..5abfdc0 100644
--- a/base/deploy/src/scriptlets/pkiparser.py
+++ b/base/deploy/src/scriptlets/pkiparser.py
@@ -53,22 +53,18 @@ def process_command_line_arguments(argv):
                            required=True, metavar='<subsystem>',
                            help='where <subsystem> is '
                                 'CA, KRA, OCSP, RA, TKS, or TPS')
+    if os.path.basename(argv[0]) == 'pkispawn':
+        mandatory.add_argument('-f',
+                               dest='pkideployment_cfg', action='store',
+                               nargs=1, required=True, metavar='<file>',
+                               help='specifies configuration filename')
     optional = parser.add_argument_group('optional arguments')
     optional.add_argument('--dry_run',
                           dest='pki_dry_run_flag', action='store_true',
                           help='do not actually perform any actions')
-    optional.add_argument('-f',
-                          dest='pkideployment_cfg', action='store',
-                          nargs=1, metavar='<file>',
-                          help='overrides default configuration filename')
     optional.add_argument('-h', '--help',
                           dest='help', action='help',
                           help='show this help message and exit')
-    optional.add_argument('-p',
-                          dest='pki_root_prefix', action='store',
-                          nargs=1, metavar='<prefix>',
-                          help='directory prefix to specify local directory '
-                               '[TEST ONLY]')
     if os.path.basename(argv[0]) == 'pkispawn':
         optional.add_argument('-u',
                               dest='pki_update_flag', action='store_true',
@@ -98,6 +94,12 @@ def process_command_line_arguments(argv):
                         dest='custom_pki_ajp_port', action='store',
                         nargs=1, metavar='<port>',
                         help='AJP port (CA, KRA, OCSP, TKS)')
+    test = parser.add_argument_group('test arguments')
+    test.add_argument('-p',
+                      dest='pki_root_prefix', action='store',
+                      nargs=1, metavar='<prefix>',
+                      help='directory prefix to specify local directory '
+                           '[TEST ONLY]')
     args = parser.parse_args()
 
     config.pki_subsystem = str(args.pki_subsystem).strip('[\']')
@@ -187,7 +189,7 @@ def process_command_line_arguments(argv):
                 print
                 parser.print_help()
                 parser.exit(-1);
-    if not args.pkideployment_cfg is None:
+    if os.path.basename(argv[0]) == 'pkispawn':
         config.pkideployment_cfg = str(args.pkideployment_cfg).strip('[\']')
     elif os.path.basename(argv[0]) == 'pkidestroy':
         # NOTE:  When performing 'pkidestroy', a configuration file must be
@@ -258,6 +260,9 @@ def read_pki_configuration_file():
         # Make keys case-sensitive!
         parser.optionxform = str
         parser.read(config.pkideployment_cfg)
+        config.pki_sensitive_dict = dict(parser._sections['Sensitive'])
+        config.pki_mandatory_dict = dict(parser._sections['Mandatory'])
+        config.pki_optional_dict = dict(parser._sections['Optional'])
         config.pki_common_dict = dict(parser._sections['Common'])
         if config.pki_subsystem == "CA":
             config.pki_web_server_dict = dict(parser._sections['Tomcat'])
@@ -278,6 +283,9 @@ def read_pki_configuration_file():
             config.pki_web_server_dict = dict(parser._sections['Apache'])
             config.pki_subsystem_dict = dict(parser._sections['TPS'])
         # Insert empty record into dictionaries for "pretty print" statements
+        #     NEVER print "sensitive" key value pairs!!!
+        config.pki_mandatory_dict[0] = None
+        config.pki_optional_dict[0] = None
         config.pki_common_dict[0] = None
         config.pki_web_server_dict[0] = None
         config.pki_subsystem_dict[0] = None
@@ -297,13 +305,19 @@ def compose_pki_master_dictionary():
             config.pki_certificate_timestamp
         config.pki_master_dict['pki_architecture'] = config.pki_architecture
         config.pki_master_dict['pki_hostname'] = config.pki_hostname
+        config.pki_master_dict['pki_dns_domainname'] =\
+            config.pki_dns_domainname
         config.pki_master_dict['pki_pin'] = config.pki_pin
         config.pki_master_dict['pki_client_pin'] = config.pki_client_pin
         config.pki_master_dict['pki_one_time_pin'] = config.pki_one_time_pin
         config.pki_master_dict['pki_dry_run_flag'] = config.pki_dry_run_flag
         config.pki_master_dict['pki_jython_log_level'] =\
             config.pki_jython_log_level
+        config.pki_master_dict['pki_deployment_cfg'] = config.pkideployment_cfg
         # Configuration file name/value pairs
+        #     NEVER add "sensitive" key value pairs to the master dictionary!!!
+        config.pki_master_dict.update(config.pki_mandatory_dict)
+        config.pki_master_dict.update(config.pki_optional_dict)
         config.pki_master_dict.update(config.pki_common_dict)
         config.pki_master_dict.update(config.pki_web_server_dict)
         config.pki_master_dict.update(config.pki_subsystem_dict)
@@ -357,8 +371,7 @@ def compose_pki_master_dictionary():
         #           (e. g. Tomcat:  "tomcat", "example.com-tomcat")
         #           (e. g. Apache:  "apache", "example.com-apache")
         #
-        if not config.pki_master_dict['pki_admin_domain_name'] is None and\
-           not config.pki_master_dict['pki_admin_domain_name'] is '':
+        if len(config.pki_master_dict['pki_admin_domain_name']):
             config.pki_master_dict['pki_instance_id'] =\
                 config.pki_master_dict['pki_admin_domain_name'] +\
                 "-" + config.pki_master_dict['pki_instance_name']
@@ -458,6 +471,9 @@ def compose_pki_master_dictionary():
                     os.path.join(config.PKI_DEPLOYMENT_SOURCE_ROOT,
                                  "ca",
                                  "emails")
+                config.pki_master_dict['pki_source_flatfile_txt'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "flatfile.txt")
                 config.pki_master_dict['pki_source_profiles'] =\
                     os.path.join(config.PKI_DEPLOYMENT_SOURCE_ROOT,
                                  "ca",
@@ -465,6 +481,43 @@ def compose_pki_master_dictionary():
                 config.pki_master_dict['pki_source_proxy_conf'] =\
                     os.path.join(config.pki_master_dict['pki_source_conf_path'],
                                  "proxy.conf")
+                config.pki_master_dict['pki_source_registry_cfg'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "registry.cfg")
+                # '*.profile'
+                config.pki_master_dict['pki_source_admincert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "adminCert.profile")
+                config.pki_master_dict['pki_source_caauditsigningcert_profile']\
+                    = os.path.join(
+                          config.pki_master_dict['pki_source_conf_path'],
+                          "caAuditSigningCert.profile")
+                config.pki_master_dict['pki_source_cacert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "caCert.profile")
+                config.pki_master_dict['pki_source_caocspcert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "caOCSPCert.profile")
+                config.pki_master_dict['pki_source_servercert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "serverCert.profile")
+                config.pki_master_dict['pki_source_subsystemcert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "subsystemCert.profile")
+            elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                # '*.profile'
+                config.pki_master_dict['pki_source_servercert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "serverCert.profile")
+                config.pki_master_dict['pki_source_storagecert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "storageCert.profile")
+                config.pki_master_dict['pki_source_subsystemcert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "subsystemCert.profile")
+                config.pki_master_dict['pki_source_transportcert_profile'] =\
+                    os.path.join(config.pki_master_dict['pki_source_conf_path'],
+                                 "transportCert.profile")
         # PKI top-level file system layout name/value pairs
         # NOTE:  Never use 'os.path.join()' whenever 'pki_root_prefix'
         #        is being prepended!!!
@@ -498,12 +551,14 @@ def compose_pki_master_dictionary():
         if config.pki_master_dict['pki_subsystem'] in\
            config.PKI_APACHE_SUBSYSTEMS:
             # Apache instance base name/value pairs
+            config.pki_master_dict['pki_instance_type'] = "Apache"
             # Apache instance log name/value pairs
             # Apache instance configuration name/value pairs
             # Apache instance registry name/value pairs
             config.pki_master_dict['pki_instance_type_registry_path'] =\
-                os.path.join(config.pki_master_dict['pki_registry_path'],
-                             "apache")
+                os.path.join(
+                    config.pki_master_dict['pki_registry_path'],
+                    config.pki_master_dict['pki_instance_type'].lower())
             config.pki_master_dict['pki_instance_registry_path'] =\
                 os.path.join(
                     config.pki_master_dict['pki_instance_type_registry_path'],
@@ -513,12 +568,16 @@ def compose_pki_master_dictionary():
         elif config.pki_master_dict['pki_subsystem'] in\
              config.PKI_TOMCAT_SUBSYSTEMS:
             # Tomcat instance base name/value pairs
+            config.pki_master_dict['pki_instance_type'] = "Tomcat"
             config.pki_master_dict['pki_tomcat_common_path'] =\
                 os.path.join(config.pki_master_dict['pki_instance_path'],
                              "common")
             config.pki_master_dict['pki_tomcat_common_lib_path'] =\
                 os.path.join(config.pki_master_dict['pki_tomcat_common_path'],
                              "lib")
+            config.pki_master_dict['pki_tomcat_tmpdir_path'] =\
+                os.path.join(config.pki_master_dict['pki_instance_path'],
+                             "temp")
             config.pki_master_dict['pki_tomcat_webapps_path'] =\
                 os.path.join(config.pki_master_dict['pki_instance_path'],
                              "webapps")
@@ -529,28 +588,43 @@ def compose_pki_master_dictionary():
                 os.path.join(
                     config.pki_master_dict['pki_tomcat_webapps_root_path'],
                     "WEB-INF")
-            config.pki_master_dict['pki_tomcat_webapps_webinf_path'] =\
-                os.path.join(config.pki_master_dict['pki_tomcat_webapps_path'],
-                             "WEB-INF")
-            config.pki_master_dict['pki_tomcat_webapps_webinf_classes_path'] =\
-                os.path.join(
-                    config.pki_master_dict['pki_tomcat_webapps_webinf_path'],
-                    "classes")
-            config.pki_master_dict['pki_tomcat_webapps_webinf_lib_path'] =\
-                os.path.join(
-                    config.pki_master_dict['pki_tomcat_webapps_webinf_path'],
-                    "lib")
             config.pki_master_dict['pki_tomcat_webapps_root_webinf_web_xml'] =\
                 os.path.join(
                     config.pki_master_dict\
                     ['pki_tomcat_webapps_root_webinf_path'],
                     "web.xml")
+            config.pki_master_dict['pki_tomcat_work_path'] =\
+                os.path.join(config.pki_master_dict['pki_instance_path'],
+                             "work")
+            config.pki_master_dict['pki_tomcat_work_catalina_path'] =\
+                os.path.join(config.pki_master_dict['pki_tomcat_work_path'],
+                             "Catalina")
+            config.pki_master_dict['pki_tomcat_work_catalina_host_path'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_work_catalina_path'],
+                    "localhost")
+            config.pki_master_dict['pki_tomcat_work_catalina_host_run_path'] =\
+                os.path.join(
+                    config.pki_master_dict\
+                    ['pki_tomcat_work_catalina_host_path'],
+                    "_")
+            config.pki_master_dict\
+            ['pki_tomcat_work_catalina_host_subsystem_path'] =\
+                os.path.join(
+                    config.pki_master_dict\
+                    ['pki_tomcat_work_catalina_host_path'],
+                    config.pki_master_dict['pki_subsystem'].lower())
             # Tomcat instance log name/value pairs
             # Tomcat instance configuration name/value pairs
+            config.pki_master_dict['pki_instance_log4j_properties'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_instance_configuration_path'],
+                    "log4j.properties")
             # Tomcat instance registry name/value pairs
             config.pki_master_dict['pki_instance_type_registry_path'] =\
-                os.path.join(config.pki_master_dict['pki_registry_path'],
-                             "tomcat")
+                os.path.join(
+                    config.pki_master_dict['pki_registry_path'],
+                    config.pki_master_dict['pki_instance_type'].lower())
             config.pki_master_dict['pki_instance_registry_path'] =\
                 os.path.join(
                     config.pki_master_dict['pki_instance_type_registry_path'],
@@ -562,9 +636,205 @@ def compose_pki_master_dictionary():
             config.pki_master_dict['pki_tomcat_lib_link'] =\
                 os.path.join(config.pki_master_dict['pki_instance_path'],
                              "lib")
+            config.pki_master_dict['pki_tomcat_lib_log4j_properties_link'] =\
+                os.path.join(config.pki_master_dict['pki_tomcat_lib_path'],
+                             "log4j.properties")
             config.pki_master_dict['pki_instance_systemd_link'] =\
                 os.path.join(config.pki_master_dict['pki_instance_path'],
                              config.pki_master_dict['pki_instance_id'])
+            # Tomcat instance common lib jars
+            if config.pki_master_dict['pki_architecture'] == 64:
+                config.pki_master_dict['pki_jss_jar'] =\
+                    os.path.join("/usr/lib64/java",
+                                 "jss4.jar")
+                config.pki_master_dict['pki_symkey_jar'] =\
+                    os.path.join("/usr/lib64/java",
+                                 "symkey.jar")
+            else:
+                config.pki_master_dict['pki_jss_jar'] =\
+                    os.path.join("/usr/lib/java",
+                                 "jss4.jar")
+                config.pki_master_dict['pki_symkey_jar'] =\
+                    os.path.join("/usr/lib/java",
+                                 "symkey.jar")
+            config.pki_master_dict['pki_apache_commons_collections_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "apache-commons-collections.jar")
+            config.pki_master_dict['pki_apache_commons_lang_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "apache-commons-lang.jar")
+            config.pki_master_dict['pki_apache_commons_logging_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "apache-commons-logging.jar")
+            config.pki_master_dict['pki_commons_codec_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "commons-codec.jar")
+            config.pki_master_dict['pki_httpclient_jar'] =\
+                os.path.join(
+                    config.PKI_DEPLOYMENT_HTTPCOMPONENTS_JAR_SOURCE_ROOT,
+                    "httpclient.jar")
+            config.pki_master_dict['pki_javassist_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "javassist.jar")
+            config.pki_master_dict['pki_resteasy_jaxrs_api_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_RESTEASY_JAR_SOURCE_ROOT,
+                             "jaxrs-api.jar")
+            config.pki_master_dict['pki_jettison_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "jettison.jar")
+            config.pki_master_dict['pki_ldapjdk_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "ldapjdk.jar")
+            config.pki_master_dict['pki_certsrv_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                             "pki-certsrv.jar")
+            config.pki_master_dict['pki_cmsbundle'] =\
+                os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                             "pki-cmsbundle.jar")
+            config.pki_master_dict['pki_cmscore'] =\
+                os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                             "pki-cmscore.jar")
+            config.pki_master_dict['pki_cms'] =\
+                os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                             "pki-cms.jar")
+            config.pki_master_dict['pki_cmsutil'] =\
+                os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                             "pki-cmsutil.jar")
+            config.pki_master_dict['pki_nsutil'] =\
+                os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                             "pki-nsutil.jar")
+            config.pki_master_dict['pki_resteasy_jaxb_provider_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_RESTEASY_JAR_SOURCE_ROOT,
+                             "resteasy-jaxb-provider.jar")
+            config.pki_master_dict['pki_resteasy_jaxrs_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_RESTEASY_JAR_SOURCE_ROOT,
+                             "resteasy-jaxrs.jar")
+            config.pki_master_dict['pki_resteasy_jettison_provider_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_RESTEASY_JAR_SOURCE_ROOT,
+                             "resteasy-jettison-provider.jar")
+            config.pki_master_dict['pki_scannotation_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "scannotation.jar")
+            config.pki_master_dict['pki_tomcatjss_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "tomcatjss.jar")
+            config.pki_master_dict['pki_velocity_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "velocity.jar")
+            config.pki_master_dict['pki_xerces_j2_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "xerces-j2.jar")
+            config.pki_master_dict['pki_xml_commons_apis_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "xml-commons-apis.jar")
+            config.pki_master_dict['pki_xml_commons_resolver_jar'] =\
+                os.path.join(config.PKI_DEPLOYMENT_JAR_SOURCE_ROOT,
+                             "xml-commons-resolver.jar")
+            # Tomcat instance common lib jar symbolic links
+            config.pki_master_dict['pki_jss_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "jss4.jar")
+            config.pki_master_dict['pki_symkey_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "symkey.jar")
+            config.pki_master_dict['pki_apache_commons_collections_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "apache-commons-collections.jar")
+            config.pki_master_dict['pki_apache_commons_lang_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "apache-commons-lang.jar")
+            config.pki_master_dict['pki_apache_commons_logging_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "apache-commons-logging.jar")
+            config.pki_master_dict['pki_commons_codec_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "apache-commons-codec.jar")
+            config.pki_master_dict['pki_httpclient_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "httpclient.jar")
+            config.pki_master_dict['pki_javassist_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "javassist.jar")
+            config.pki_master_dict['pki_resteasy_jaxrs_api_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "jaxrs-api.jar")
+            config.pki_master_dict['pki_jettison_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "jettison.jar")
+            config.pki_master_dict['pki_ldapjdk_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "ldapjdk.jar")
+            config.pki_master_dict['pki_certsrv_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "pki-certsrv.jar")
+            config.pki_master_dict['pki_cmsbundle_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "pki-cmsbundle.jar")
+            config.pki_master_dict['pki_cmscore_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "pki-cmscore.jar")
+            config.pki_master_dict['pki_cms_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "pki-cms.jar")
+            config.pki_master_dict['pki_cmsutil_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "pki-cmsutil.jar")
+            config.pki_master_dict['pki_nsutil_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "pki-nsutil.jar")
+            config.pki_master_dict['pki_resteasy_jaxb_provider_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "resteasy-jaxb-provider.jar")
+            config.pki_master_dict['pki_resteasy_jaxrs_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "resteasy-jaxrs.jar")
+            config.pki_master_dict['pki_resteasy_jettison_provider_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "resteasy-jettison-provider.jar")
+            config.pki_master_dict['pki_scannotation_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "scannotation.jar")
+            config.pki_master_dict['pki_tomcatjss_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "tomcatjss.jar")
+            config.pki_master_dict['pki_velocity_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "velocity.jar")
+            config.pki_master_dict['pki_xerces_j2_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "xerces-j2.jar")
+            config.pki_master_dict['pki_xml_commons_apis_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "xml-commons-apis.jar")
+            config.pki_master_dict['pki_xml_commons_resolver_jar_link'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_common_lib_path'],
+                    "xml-commons-resolver.jar")
         # Instance layout NSS security database name/value pairs
         config.pki_master_dict['pki_database_path'] =\
             os.path.join(
@@ -612,9 +882,6 @@ def compose_pki_master_dictionary():
         elif config.pki_master_dict['pki_subsystem'] in\
              config.PKI_TOMCAT_SUBSYSTEMS:
             # Instance-based Tomcat PKI subsystem base name/value pairs
-            config.pki_master_dict['pki_tomcat_webapps_subsystem_path'] =\
-                os.path.join(config.pki_master_dict['pki_tomcat_webapps_path'],
-                             config.pki_master_dict['pki_subsystem'].lower())
             if config.pki_master_dict['pki_subsystem'] == "CA":
                 config.pki_master_dict['pki_subsystem_emails_path'] =\
                 os.path.join(config.pki_master_dict['pki_subsystem_path'],
@@ -632,18 +899,6 @@ def compose_pki_master_dictionary():
             config.pki_master_dict['pki_subsystem_tomcat_webapps_link'] =\
                 os.path.join(config.pki_master_dict['pki_subsystem_path'],
                              "webapps")
-            config.pki_master_dict\
-            ['pki_tomcat_webapps_subsystem_webinf_classes_link'] =\
-                os.path.join(
-                    config.pki_master_dict['pki_tomcat_webapps_subsystem_path'],
-                    "WEB-INF",
-                    "classes")
-            config.pki_master_dict\
-            ['pki_tomcat_webapps_subsystem_webinf_lib_link'] =\
-                os.path.join(
-                    config.pki_master_dict['pki_tomcat_webapps_subsystem_path'],
-                    "WEB-INF",
-                    "lib")
         # Instance-based Apache/Tomcat PKI subsystem convenience symbolic links
         config.pki_master_dict['pki_subsystem_database_link'] =\
             os.path.join(config.pki_master_dict['pki_subsystem_path'],
